/******************************************************************************
*
* Copyright (C) 2009 - 2014 Xilinx, Inc.  All rights reserved.
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* Use of the Software is limited solely to applications:
* (a) running on a Xilinx device, or
* (b) that interact with a Xilinx device through a bus or interconnect.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
* XILINX  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* Except as contained in this notice, the name of the Xilinx shall not be used
* in advertising or otherwise to promote the sale, use or other dealings in
* this Software without prior written authorization from Xilinx.
*
******************************************************************************/

/*
 * helloworld.c: simple test application
 *
 * This application configures UART 16550 to baud rate 9600.
 * PS7 UART (Zynq) is not initialized by this application, since
 * bootrom/bsp configures it to baud rate 115200
 *
 * ------------------------------------------------
 * | UART TYPE   BAUD RATE                        |
 * ------------------------------------------------
 *   uartns550   9600
 *   uartlite    Configurable only in HW design
 *   ps7_uart    115200 (configured by bootrom/bsp)
 */

#include <stdio.h>
#include "platform.h"
#include "xil_printf.h"
#include "AXIWS2812Strip.h"
#include "xparameters.h"

//#define XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR 0x43C00000

int main()
{
    init_platform();

    //print("Hello World\n\r");

    uint16_t status = 0;
    uint32_t led_addr = 140;
    uint32_t led_value = 0x00FF0000;

    uint8_t red = 0;
    uint8_t green = 0;
    uint8_t blue = 0;

    AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET, 4); // write = 0 | display = 0 | reset = 1
    AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET, 0); // write = 0 | display = 0 | reset = 0

    while(1) {
    	status = AXIWS2812STRIP_mReadReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET);
    	if(status == 0) {

    		AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET, 0); // write = 0 | display = 0
    		AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG1_OFFSET, led_addr);
    		AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG2_OFFSET, led_value);
    		AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET, 1); // write = 1 | display = 0

    		AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET, 2); // write = 0 | display = 1
    		AXIWS2812STRIP_mWriteReg(XPAR_AXIWS2812STRIP_0_S00_AXI_BASEADDR, AXIWS2812STRIP_S00_AXI_SLV_REG0_OFFSET, 0); // write = 0 | display = 0
    		led_addr++;
    		if(led_addr == 150) {
    			led_addr = 0;
    			red = red + 1;
				green = green - 10;
				blue = blue + 2;
				led_value = blue;
				led_value = (led_value << 8) | green;
				led_value = (led_value << 8) | red;
    		}
    	}
    }

    cleanup_platform();
    return 0;
}
